Loading...
Searching...
No Matches
juce::EnumerateIterator< Iter, Index > Class Template Reference

## Detailed Description

template<typename Iter, typename Index = ptrdiff_t>
class juce::EnumerateIterator< Iter, Index >

An iterator that wraps some other iterator, keeping track of the relative position of that iterator based on calls to arithmetic operators such as operator++(), operator--(), operator+(), and operator-().

You should never need to construct an instance of this type yourself. Instead, use the enumerate() function to construct a range that can be enumerated.

See also
  enumerate()

The documentation for this class was generated from the following file:

- juce_core/containers/juce_Enumerate.h

## Public Member Functions

constexpr | EnumerateIterator ()=default
| Default constructor.
constexpr | EnumerateIterator (Iter iter)
| Wraps the provided iterator, and sets the internal count to 0.
constexpr | EnumerateIterator (Iter iter, Index ind)
| Wraps the provided iterator, and sets the internal count to the provided value.
template<typename OtherIter, typename OtherInd>
constexpr bool | operator== (const EnumerateIterator< OtherIter, OtherInd > &other) const
| Two EnumerateIterators are considered equal if the wrapped iterators are equal.
template<typename OtherIter, typename OtherInd>
constexpr bool | operator!= (const EnumerateIterator< OtherIter, OtherInd > &other) const
constexpr Enumerated< Index, decltype(*std::declval< Iter >())> | operator* () const
| Dereferencing the iterator produces an Enumerated instance by value.
constexpr EnumerateIterator & | operator++ ()
| Increments the iterator and the index.
constexpr EnumerateIterator | operator++ (int)
| Increments the iterator and the index.
template<typename T = Iter, std::enable_if_t< detail::canPreDecrement< T >, int > = 0>
constexpr EnumerateIterator & | operator-- ()
| Decrements the iterator and the index.
template<typename T = Iter, std::enable_if_t< detail::canPreDecrement< T >, int > = 0>
constexpr EnumerateIterator | operator-- (int)
| Decrements the iterator and the index.
template<typename I, std::enable_if_t< detail::canAddAssign< Iter &, I >, int > = 0>
constexpr EnumerateIterator & | operator+= (I diff)
| Adds an integral value to both the iterator and the index.
template<typename I, std::enable_if_t< detail::canSubAssign< Iter &, I >, int > = 0>
constexpr EnumerateIterator & | operator-= (I diff)
| Subtracts an integral value from both the iterator and the index.
template<typename OtherIter, typename OtherInd, std::enable_if_t< detail::canSub< Iter, OtherIter >, int > = 0>
constexpr auto | operator- (const EnumerateIterator< OtherIter, OtherInd > &other) const
| Subtracts another enumerate iterator from this one, producing the same result as subtracting the two wrapped iterators.
template<typename I, std::enable_if_t< detail::canAdd< EnumerateIterator, I >, int > = 0>
constexpr auto | operator[] (I diff) const
| Indexes into this iterator, equivalent to adding an integral value to this iterator and then dereferencing the result.
template<typename OtherIter, typename OtherInd, std::enable_if_t< detail::canLessThan< Iter, OtherIter >, int > = 0>
constexpr bool | operator< (const EnumerateIterator< OtherIter, OtherInd > &other) const
| Returns the result of comparing the two wrapped iterators.
template<typename OtherIter, typename OtherInd, std::enable_if_t< detail::canLessThanEqual< Iter, OtherIter >, int > = 0>
constexpr bool | operator<= (const EnumerateIterator< OtherIter, OtherInd > &other) const
| Returns the result of comparing the two wrapped iterators.
template<typename OtherIter, typename OtherInd, std::enable_if_t< detail::canGreaterThan< Iter, OtherIter >, int > = 0>
constexpr bool | operator> (const EnumerateIterator< OtherIter, OtherInd > &other) const
| Returns the result of comparing the two wrapped iterators.
template<typename OtherIter, typename OtherInd, std::enable_if_t< detail::canGreaterThanEqual< Iter, OtherIter >, int > = 0>
constexpr bool | operator>= (const EnumerateIterator< OtherIter, OtherInd > &other) const
| Returns the result of comparing the two wrapped iterators.

## Constructors and Destructors

## EnumerateIterator() [1/3]

template<typename Iter, typename Index = ptrdiff_t>

juce::EnumerateIterator< Iter, Index >::EnumerateIterator | ( |  | ) |

constexpr default

Default constructor.

Referenced by EnumerateIterator(), operator!=(), operator+, operator+, operator++(), operator++(), operator+=(), operator-(), operator-, operator--(), operator--(), operator-=(), operator<(), operator<=(), operator==(), operator>(), and operator>=().

## EnumerateIterator() [2/3]

template<typename Iter, typename Index = ptrdiff_t>

juce::EnumerateIterator< Iter, Index >::EnumerateIterator | ( | Iter | iter | ) |

inline explicit constexpr

Wraps the provided iterator, and sets the internal count to 0.

References EnumerateIterator().

## EnumerateIterator() [3/3]

template<typename Iter, typename Index = ptrdiff_t>

juce::EnumerateIterator< Iter, Index >::EnumerateIterator | ( | Iter | iter,
|  | Index | ind )

inline constexpr

Wraps the provided iterator, and sets the internal count to the provided value.

## Member Functions

## operator==()

template<typename Iter, typename Index = ptrdiff_t>
template<typename OtherIter, typename OtherInd>

bool juce::EnumerateIterator< Iter, Index >::operator== | ( | const EnumerateIterator< OtherIter, OtherInd > & | other | ) | const

inline nodiscard constexpr

Two EnumerateIterators are considered equal if the wrapped iterators are equal.

References EnumerateIterator().

Referenced by operator!=().

## operator!=()

template<typename Iter, typename Index = ptrdiff_t>
template<typename OtherIter, typename OtherInd>

bool juce::EnumerateIterator< Iter, Index >::operator!= | ( | const EnumerateIterator< OtherIter, OtherInd > & | other | ) | const

inline nodiscard constexpr

See also
  operator==()

References EnumerateIterator(), and operator==().

## operator*()

template<typename Iter, typename Index = ptrdiff_t>

Enumerated< Index, decltype(*std::declval< Iter >())> juce::EnumerateIterator< Iter, Index >::operator* | ( |  | ) | const

inline nodiscard constexpr

Dereferencing the iterator produces an Enumerated instance by value.

This type holds a copy of the iterator's current index, along with the result of dereferencing the wrapped iterator (normally a reference type).

## operator++() [1/2]

template<typename Iter, typename Index = ptrdiff_t>

EnumerateIterator & juce::EnumerateIterator< Iter, Index >::operator++ | ( |  | ) |

inline constexpr

Increments the iterator and the index.

References EnumerateIterator().

Referenced by operator++().

## operator++() [2/2]

template<typename Iter, typename Index = ptrdiff_t>

EnumerateIterator juce::EnumerateIterator< Iter, Index >::operator++ | ( | int |  | ) |

inline constexpr

Increments the iterator and the index.

References EnumerateIterator(), and operator++().

## operator--() [1/2]

template<typename Iter, typename Index = ptrdiff_t>
template<typename T = Iter, std::enable_if_t< detail::canPreDecrement< T >, int > = 0>

EnumerateIterator & juce::EnumerateIterator< Iter, Index >::operator-- | ( |  | ) |

inline constexpr

Decrements the iterator and the index.

Only participates in overload resolution if the iterator can be pre-decremented.

References EnumerateIterator().

Referenced by operator--().

## operator--() [2/2]

template<typename Iter, typename Index = ptrdiff_t>
template<typename T = Iter, std::enable_if_t< detail::canPreDecrement< T >, int > = 0>

EnumerateIterator juce::EnumerateIterator< Iter, Index >::operator-- | ( | int |  | ) |

inline constexpr

Decrements the iterator and the index.

Only participates in overload resolution if the iterator can be pre-decremented.

References EnumerateIterator(), and operator--().

## operator+=()

template<typename Iter, typename Index = ptrdiff_t>
template<typename I, std::enable_if_t< detail::canAddAssign< Iter &, I >, int > = 0>

EnumerateIterator & juce::EnumerateIterator< Iter, Index >::operator+= | ( | I | diff | ) |

inline constexpr

Adds an integral value to both the iterator and the index.

Only participates in overload resolution if the iterator can be add-assigned.

References EnumerateIterator().

## operator-=()

template<typename Iter, typename Index = ptrdiff_t>
template<typename I, std::enable_if_t< detail::canSubAssign< Iter &, I >, int > = 0>

EnumerateIterator & juce::EnumerateIterator< Iter, Index >::operator-= | ( | I | diff | ) |

inline constexpr

Subtracts an integral value from both the iterator and the index.

Only participates in overload resolution if the iterator can be sub-assigned.

References EnumerateIterator().

## operator-()

template<typename Iter, typename Index = ptrdiff_t>
template<typename OtherIter, typename OtherInd, std::enable_if_t< detail::canSub< Iter, OtherIter >, int > = 0>

auto juce::EnumerateIterator< Iter, Index >::operator- | ( | const EnumerateIterator< OtherIter, OtherInd > & | other | ) | const

inline nodiscard constexpr

Subtracts another enumerate iterator from this one, producing the same result as subtracting the two wrapped iterators.

For random-access iterators, this will normally return the distance between the two iterators. Only participates in overload resolution if the wrapped iterators can be subtracted.

References EnumerateIterator().

## operator[]()

template<typename Iter, typename Index = ptrdiff_t>
template<typename I, std::enable_if_t< detail::canAdd< EnumerateIterator, I >, int > = 0>

auto juce::EnumerateIterator< Iter, Index >::operator[] | ( | I | diff | ) | const

inline nodiscard constexpr

Indexes into this iterator, equivalent to adding an integral value to this iterator and then dereferencing the result.

Only participates in overload resolution if the wrapped iterator allows addition of integral values.

## operator<()

template<typename Iter, typename Index = ptrdiff_t>
template<typename OtherIter, typename OtherInd, std::enable_if_t< detail::canLessThan< Iter, OtherIter >, int > = 0>

bool juce::EnumerateIterator< Iter, Index >::operator< | ( | const EnumerateIterator< OtherIter, OtherInd > & | other | ) | const

inline nodiscard constexpr

Returns the result of comparing the two wrapped iterators.

Only participates in overload resolution if the wrapped iterators are comparable.

References EnumerateIterator().

## operator<=()

template<typename Iter, typename Index = ptrdiff_t>
template<typename OtherIter, typename OtherInd, std::enable_if_t< detail::canLessThanEqual< Iter, OtherIter >, int > = 0>

bool juce::EnumerateIterator< Iter, Index >::operator<= | ( | const EnumerateIterator< OtherIter, OtherInd > & | other | ) | const

inline nodiscard constexpr

Returns the result of comparing the two wrapped iterators.

Only participates in overload resolution if the wrapped iterators are comparable.

References EnumerateIterator().

## operator>()

template<typename Iter, typename Index = ptrdiff_t>
template<typename OtherIter, typename OtherInd, std::enable_if_t< detail::canGreaterThan< Iter, OtherIter >, int > = 0>

bool juce::EnumerateIterator< Iter, Index >::operator> | ( | const EnumerateIterator< OtherIter, OtherInd > & | other | ) | const

inline nodiscard constexpr

Returns the result of comparing the two wrapped iterators.

Only participates in overload resolution if the wrapped iterators are comparable.

References EnumerateIterator().

## operator>=()

template<typename Iter, typename Index = ptrdiff_t>
template<typename OtherIter, typename OtherInd, std::enable_if_t< detail::canGreaterThanEqual< Iter, OtherIter >, int > = 0>

bool juce::EnumerateIterator< Iter, Index >::operator>= | ( | const EnumerateIterator< OtherIter, OtherInd > & | other | ) | const

inline nodiscard constexpr

Returns the result of comparing the two wrapped iterators.

Only participates in overload resolution if the wrapped iterators are comparable.

References EnumerateIterator().

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited